#include "config.h"
#include "send.h"

int HelpSub(char *Target, char *Source)
{
   char* ptr;
   int i;

   for(ptr = Source; *ptr != '\0';ptr++)
   {
      if(*ptr == '$')
      {
         ptr++; 
         switch(*ptr)
         {
           case 't': /* network name */
               for(i=0;NETWORK[i] != '\0';i++)
               {
                  *Target = NETWORK[i];
                  Target++;
               }
               break;
           case 'n': /* My nick */
               for(i=0;IrcNick[i] != '\0';i++)
               {
                  *Target = IrcNick[i];
                  Target++;
               }
               break;
           case 'c': /* Command char */
               *Target = CommandMark;
               Target++;
               break;
           case 'w': /* Web URL */
               for(i=0;HELPURL[i] != '\0';i++)
               {
                  *Target = HELPURL[i];
                  Target++;
               }
               break;
           default: 
               *Target = '$';
               Target++;
               *Target = *ptr;
               Target++;
               break;
         }
         ptr++;

      }
      *Target = *ptr;
      Target++;
   }
   *Target=0;
   return 0;
}

int ShowCommHelp(UserListType uptr, FILE * HelpFile)
{

  /* swap needs to be big enough to hold the input string
   * PLUS the extra size of swapped out pieces. */
  char Buffer[LINEBUFFSIZE + 1];
  char SwapBuff[LINEBUFFSIZE + MAXLEN];
  int c;

  while((c = fgets(Buffer, LINEBUFFSIZE, HelpFile) != NULL))
  {
    Buffer[strlen(Buffer) - 1] = '\0';
    HelpSub(SwapBuff, Buffer);
    send_to_user(uptr, "%s", SwapBuff);
  }
  return(TRUE);
}

int ShowUserHelp(UserListType uptr, FILE * HelpFile)
{
  char Buffer[LINEBUFFSIZE + 1];
  char SwapBuff[LINEBUFFSIZE + MAXLEN];

  int c;

  while((c = fgets(Buffer, LINEBUFFSIZE, HelpFile) != NULL))
  {
    Buffer[strlen(Buffer) - 1] = '\0';
    HelpSub(SwapBuff, Buffer);
    send_to_user(uptr, "%s", SwapBuff);
  }
  return(TRUE);
}

int ShowOperHelp(UserListType uptr, FILE * HelpFile)
{

  char Buffer[LINEBUFFSIZE + 1];
  char SwapBuff[LINEBUFFSIZE + MAXLEN];

  int c;

  while((c = fgets(Buffer, LINEBUFFSIZE, HelpFile) != NULL))
  {
    Buffer[strlen(Buffer) - 1] = '\0';
    HelpSub(SwapBuff, Buffer);
    send_to_user(uptr, "%s", SwapBuff);
  }
  return(TRUE);
}


