extern char *crypt (__const char *__key, __const char *__salt);
void genpass(char *str, int len);
int PassOk(char *Pass);
#if !defined(isblank)
#define isblank(c)   ((c == 32) || (c == 9))
#endif
char *unsigned32ToDotQuad(unsigned long int ip);
char *NickToNum(char *nick);
char *NumToNick(char *num);
char *time2str(time_t thetime);
char *mysep(char **sepstr, char *delim);
void safecopy(char *dest, char *source, int size);
int SendMOTD(UserListType uptr);
void WriteGlineDat();
void WriteSGlineDat();
void LogCommand(ChannelListType cptr, UserListType uptr, HandleListType hptr,
                char* command, char* rest, int ChanSecurity, int HelpOverride);
void Debug(int Level, char *fmt,...);
time_t NetTime();
char *t2s(char *s, time_t stamp);
void SendNetMessage(UserListType uptr);
int isinchan(ChannelListType cptr, UserListType uptr);
int opok(ChannelListType ChanPtr, UserListType uptr, UserListType optr);
int deopok(ChannelListType ChanPtr, UserListType from, UserListType to);
int halfopok(ChannelListType ChanPtr, UserListType uptr, UserListType optr);
int dehalfopok(ChannelListType ChanPtr, UserListType from, UserListType to);
int kickok(ChannelListType ChanPtr, UserListType from, UserListType to);
int modeok(ChannelListType ChanPtr, UserListType from);
int banok(ChannelListType ChanPtr, UserListType from, char* mask);
void punish(ChannelListType ChanPtr, UserListType from, UserListType to, char type);
void SysPrep(char *str);
int isiphost(char *hostname);
int IsAllDigits(char *string);
void CheckSpoof(char *stat);
void ban_user(ChannelListType cptr, UserListType uptr);
void deopban(ChannelListType cptr, UserListType uptr, char *mask);
void ban_mask(ChannelListType cptr, char *mask);
char *strip(char *temp, char c);
char *right(char *string, int num);
int numchar(char *string, char c);
char *cluster(char *userhost);
time_t getthetime(void);
int ischannel(char *channel);
int userlevel2(UserListType uptr, HandleListType hptr);
char levelcharfromname(char *level);
char levelcharfromint(int theint);
char *levelnamefromchar(char thechar);
char *levelnamefromint(int theint);
int userlevelbychar(char thechar);
int userlevel(HandleListType hptr);
int userleveloper(UserListType uptr, HandleListType hptr);
char *GetSetting(boolean Setting);
char *GetCloneResMet(int Setting);
char *GetWinGateMet(int Setting);
char *MakeUpper(char *Str);
char *UpCase(char *Str);
boolean NickOk(char *Nick);
boolean ChanOk(char *Chan);
boolean ModeOk(char *Mode);
int HandleOk(char *Handle);
int KeyOk(char *Key);
int AddyOk(char *Address);
int GlineAddyOk(char *Address);
int GetModeNum(char *Mode);
char *reconstruct(int ac, char **av, int start);
int calcmaskweight(char *mask);
char OpCh(int Aop);
char *NameCh(char *Name);
void do_math(char *buff, char *math);
unsigned long Hash(char *str);
unsigned int base64toint(const char *s);
const char* inttobase64(char* buf, unsigned int v, unsigned int count);
void LogAccess(UserListType uptr, char* item, int size);
char *ActiveHost(UserListType uptr);
char *ActiveUsername(UserListType uptr);
